IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc
	.686
.xmm
    atol      PROTO :DWORD
	atol_2  PROTO :DWORD
    atolsL   PROTO :DWORD


    tdelay    PROTO

    ncnt equ <256>                  ; padding count
    padd equ <int 3>

    dalg equ <16>                   ; change data alignment here
    palg equ <16>                   ; change data pointer alignment here

    icnt equ <10000000>             ; iteration count

  ; ---------------------------
  ; set processor core (1 to 4)
  ; ---------------------------
    Core MACRO corenum
      mov eax, 1
      .if eax == 1
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000001b
      .elseif eax == 2
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000010b
      .elseif eax == 3
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000100b
      .elseif eax == 4
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000001000b
      .else
        xor ecx, ecx
      .endif
    ENDM
  ; ---------------------------


    .data
      align dalg
      itm1 db "2147483647",0
      align dalg
      itm2 db "-2147483648",0
      align dalg
      itm3 db "012345",0
      align dalg
      itm4 db "-012345",0

      align palg
      item1 dd itm1
      align palg
      item2 dd itm2
      align palg
      item3 dd itm3
      align palg
      item4 dd itm4

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL tmr1 :DWORD
    LOCAL tmr2 :DWORD
    LOCAL tmr3 :DWORD
    LOCAL tmr4 :DWORD
    LOCAL tmr5 :DWORD
    LOCAL tmr6 :DWORD

    mov tmr1, 0
    mov tmr2, 0
	mov tmr3, 0

    push ebx
    push esi
    push edi

  ; -----------------------------
  ; set the processor core to use
  ; -----------------------------
    Core 1    

 ;     invoke SetPriorityClass,rv(GetCurrentProcess),HIGH_PRIORITY_CLASS
 ;     invoke SetThreadPriority,rv(GetCurrentThread),THREAD_PRIORITY_HIGHEST

    invoke SleepEx,1000,0
    rdtsc

    mov edi, 4

  tloop:

  ; ==============================

    invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke atol,item1
    invoke atol,item2
    invoke atol,item3
    invoke atol,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr1, eax

    print ustr$(eax)," atol",13,10

    invoke SleepEx,1000,0

  ; ==============================
  
     invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke atolsL,item1
    invoke atolsL,item2
    invoke atolsL,item3
    invoke atolsL,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr2, eax

    print ustr$(eax)," atolsLingo",13,10

    invoke SleepEx,1000,0

  ; ==============================
     invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke atol_2,item1
    invoke atol_2,item2
    invoke atol_2,item3
    invoke atol_2,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr3, eax

    print ustr$(eax)," atol_2qword",13,10

    invoke SleepEx,1000,0

  ; ==============================  
 
  ; ==============================

    sub edi, 1
    jnz tloop

    shr tmr1, 2
    shr tmr2, 2
	shr tmr3, 2

    print chr$(13,10,13,10)

    print ustr$(tmr1)," ms average atol",13,10
    print ustr$(tmr2)," ms average atolsLingo",13,10
	print ustr$(tmr3)," ms average atol_2qWord",13,10

 ;     invoke SetThreadPriority,rv(GetCurrentThread),THREAD_PRIORITY_NORMAL
 ;     invoke SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

    REPEAT ncnt
      padd
    ENDM

atol proc String:DWORD
	xor eax, eax
    mov edx, [esp+4]            ; lpSrc
    movzx ecx, BYTE PTR [edx]
    add edx, 1

    cmp ecx, "-"
    jne lbl0
    add eax, 1
    movzx ecx, BYTE PTR [edx]
    add edx, 1
  lbl0:
    mov [esp+4], eax            ; keep sign on stack
    xor eax, eax
    sub ecx, 48
    jc  lbl2

  lbl1:
    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        ; then mul by 2
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    sub ecx, 48
    jc  lbl2

    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        ; then mul by 2
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    sub ecx, 48
    jnc  lbl1

  lbl2:
    mov ecx, [esp+4]            ; retrieve sign
    test ecx, ecx
    jz lbl3
    neg eax                     ; negative return value is sign set
  lbl3:

    ret 4
atol endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

    REPEAT ncnt
      padd
    ENDM

atol_2 proc String:DWORD
	mov edx,[esp+4] ;pszSrc
	movzx ecx,BYTE ptr [edx]
	test ecx,ecx
	jz @err
	cmp ecx,'-'
	jz @2
		lea eax,[ecx-'0']
		cntr = 1
		REPEAT 9
			movzx ecx,BYTE ptr [edx+cntr]
			test ecx,ecx
		@@:	jnz @F
			ret 4
		@@:
			lea eax,[eax*4+eax]
			lea eax,[eax*2+ecx-'0']
			cntr = cntr + 1
		ENDM
		ret 4

	align 16
@2:
		movzx ecx,BYTE ptr [edx+1]
		test ecx,ecx
		jz @fin2
		lea eax,[ecx-'0']
		cntr = 2
		REPEAT 9
			movzx ecx,BYTE ptr [edx+cntr]
			test ecx,ecx
			jz @fin2
			lea eax,[eax*4+eax]
			lea eax,[eax*2+ecx-'0']
			cntr = cntr + 1
		ENDM
		;align 16
	@fin2:
		neg eax
		ret 4
	
	align 16
@err:
	ret 4
atol_2 endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE


    REPEAT ncnt
      padd
    ENDM


align 16
db 3 Dup(0)
atolsL proc String:DWORD
	pop			ecx
	pop			edx
    movzx		eax,  byte ptr [edx]
    cmp			eax, 2Dh
	jb				@f
	movzx		ecx,  byte ptr [edx+1]
	je				Vil2
	test			ecx, ecx
    je				Vil12
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h*11]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+2]
     je			@f 
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+3]
     je			@f
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+4]
	 je			@f
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+5]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+6]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+7]
     jz			@f 
	  lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+8]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+9]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	jmp			dword ptr [esp-2*4]
Vil12:
	 sub			eax, 30h
@@:
	jmp			dword ptr [esp-2*4]
	db			12 dup(0)
Vil2:
	 test			ecx, ecx
     jz			Vil4 ;@f	-4
	 mov		eax, ecx
	 movzx	ecx,  byte ptr [edx+2]
	 test			ecx, ecx
     jz			Vil4a ;@f	-4
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h*11]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+3]
     jz			@f 
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+4]
     jz			@f
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+5]
     jz			@f
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+6]
     jz			@f
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+7]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+8]
     jz			@f 
	  lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+9]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+10]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	neg			eax
	jmp			dword ptr [esp-2*4]
Vil4:
	xor			eax, eax
	jmp			dword ptr [esp-2*4]
Vil4a:
	 sub			eax, 30h
	 nop
 @@:
	neg			eax
	jmp			dword ptr [esp-2*4]	

atolsL endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

    REPEAT ncnt
      padd
    ENDM
tdelay proc

    mov eax, 10000000
    mov ecx, 10000000
    mov edx, 10000000

  @@:
    sub eax, 1
    sub ecx, 1
    sub edx, 1
    jnz @B

    ret

tdelay endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end start
